using namespace std;
#include "Aluno.h"
#pragma once

/**
 * Não alterar este ficheiro
 */
 
// Classe ABP
class ABP{
    public:
    
    Aluno *aluno;
    ABP *direita, *esquerda;
    
    // Construtor de uma árvore binária de pesquisa vazia
    ABP();
 
    // Insere o aluno apontado por a na ABP (considerando como chave o número de aluno)
    void insere(Aluno *a);
    
    // Apaga, da ABP raiz, o aluno apontado por a (considere como chave o número de aluno)
    // Deve implementar o algoritmo de remoção por cópia, usando sempre o item sucessor
    ABP * apaga(ABP * raiz, Aluno *a);
    
    // Procura na ABP e devolve um apontador para o aluno com o número igual ao passado como parâmetro
    // deve devolver NULL se aluno não existe na ABP
    Aluno* procura(int numero);
    
    // Procura na ABP e devolve um apontador para o aluno com o menor número de aluno
    // deve devolver NULL se aluno não existe na ABP
    Aluno* menor();
    
    // Imprime o conteúdo da árvore do forma ordenada (pelo número de aluno)
    // Deve imprimir no formato: "NumAluno, Nome" com cada aluno numa linha diferente
    // Exemplo:
    // 1, Ana
    // 2, Beatriz
    // 3, Carla
    void imprime_ordenado();
    
    // Destrutor da ABP
    ~ABP();
};